/*
 * rgbled.h
 *
 *  Created on: Nov 11, 2021
 *      Author: dooku
 */

#ifndef INC_RGBLED_H_
#define INC_RGBLED_H_

#include "stm32l0xx_ll_tim.h"
#include "stddef.h"

/*
 * Return values for I2C functions
 */

#define RGBLED_OK 0
#define RGBLED_ERROR -1 // generic error

#define RGBLED_PRESCALER 0
#define RGBLED_PERIOD 255

/*
 * Type definitions
 */

typedef struct {
	// tim2 ch1 B
	// tim22 ch1 G
	// tim22 ch2 R
	// TODO union, aby se dalo nastavovat LED v cyklu (set_color)
	TIM_TypeDef *timer_R;
	TIM_TypeDef *timer_G;
	TIM_TypeDef *timer_B;
	uint8_t channel_R;
	uint8_t channel_G;
	uint8_t channel_B;

} rgbled_context_t;

/*
 * Function declarations
 */

int8_t rgbled_init(rgbled_context_t *context);
int8_t rgbled_set_color(uint16_t R, uint16_t G, uint16_t B);
int8_t rgbled_off(void);


#endif /* INC_RGBLED_H_ */
