/*
 * rgbled.c
 *
 *  Created on: Nov 11, 2021
 *      Author: dooku
 */

#include "rgbled.h"

static rgbled_context_t *rgbled_context;


int8_t rgbled_init(rgbled_context_t *context)
{
	if (context == NULL) {
		return RGBLED_ERROR;
	}
	rgbled_context = context;

	return RGBLED_OK;
}

int8_t rgbled_set_color(uint16_t R, uint16_t G, uint16_t B)
{
	// tim2 ch1 B
	// tim22 ch1 G
	// tim22 ch2 R
	if (
			R > RGBLED_PERIOD || \
			G > RGBLED_PERIOD || \
			B > RGBLED_PERIOD)
	{
		return RGBLED_ERROR;
	}
	LL_TIM_OC_SetCompareCH1(rgbled_context->timer_B, (uint32_t)(RGBLED_PERIOD - B)); // B
	LL_TIM_OC_SetCompareCH1(rgbled_context->timer_G, (uint32_t)(RGBLED_PERIOD - G)); // G
	LL_TIM_OC_SetCompareCH2(rgbled_context->timer_R, (uint32_t)(RGBLED_PERIOD - R)); // R

	return RGBLED_OK;
}

int8_t rgbled_off(void)
{

}
